﻿<?php
/*
Plugin Name: WP Zenno
Plugin URI:  http://astraport.ru
Description: Плагин для автоматизированного создания постов, аватарок, авторов, категорий, меню и т. д. с помощью ZennoPoster.
Version:     1.0
Author:      Astraport
Author URI:  http://astraport.ru
License:     GPL2 etc
License URI: http://astraport.ru

*/
//Устанавливаем аватарку по урлу
function set_avatar_url(WP_REST_Request $request) {
        $data = $request->get_params();
include_once( ABSPATH . 'wp-admin/includes/image.php' );
$imageurl = $data['avatar_url'];
$imagetype = end(explode('/', getimagesize($imageurl)['mime']));
$uniq_name = date('dmY').''.(int) microtime(true); 
$filename = $uniq_name.'.'.$imagetype;

$uploaddir = wp_upload_dir();
$uploadfile = $uploaddir['path'] . '/' . $filename;
$contents= file_get_contents($imageurl);
$savefile = fopen($uploadfile, 'w');
fwrite($savefile, $contents);
fclose($savefile);

$wp_filetype = wp_check_filetype(basename($filename), null );
$attachment = array(
    'post_mime_type' => $wp_filetype['type'],
    'post_title' => $filename,
    'post_content' => '',
    'post_status' => 'inherit'
);

$attach_id = wp_insert_attachment( $attachment, $uploadfile );
$imagenew = get_post( $attach_id );
$fullsizepath = get_attached_file( $imagenew->ID );
$attach_data = wp_generate_attachment_metadata( $attach_id, $fullsizepath );
wp_update_attachment_metadata( $attach_id, $attach_data ); 
global $wpdb;
$resultss = update_user_meta($data['id'], $wpdb->get_blog_prefix() . 'user_avatar', $attach_id);  
print_r($resultss); 
}

//получаем все меню используемые на сайте
function get_all_registered_nav_menus() {
print_r(get_registered_nav_menus());
}

//функция создания родительского итема
function generate_site_nav_menu_item( $term_id, $title, $url ) {
   
    $p_id = wp_update_nav_menu_item($term_id, 0, array(
        'menu-item-title'   =>  sprintf( __('%s', 'text_domain'), $title ),
        'menu-item-url'     =>  home_url( '/' . $url ),
        'menu-item-status'  =>  'publish'
    ) );
   return $p_id;
}

//создание меню для многоязыкового сайта
function generate_site_nav_menu(WP_REST_Request $request) {  
$data = $request->get_params();
 
$menu_primary = $data['menu_name'];
$result = wp_create_nav_menu( $menu_primary );
$menu_primary_obj = get_term_by( 'name', $menu_primary, 'nav_menu' );
$location_target = $data['location_target'];

$menu_items_array = json_decode($data['menu_items_array']);
$menu_items_array_count = count($data);
$pos1 = -1;
$pos2 = -1;

for ($x = 0; $x < $menu_items_array_count; $x++) {
$str = $data['menu_items_array_'.$x];
	if (strlen($str) > 0 && $pos1 == -1) {
$pos1 = $x;
	} elseif (strlen($str) > 0 && $pos2 == -1) {
$pos2 = $x;
}
}
//print_r($pos1." - ".$pos2);
$i = 0;
$parent_id = array();
foreach( $menu_items_array as $page_name => $page_location ){
	$parent_id[$i] = generate_site_nav_menu_item( $menu_primary_obj->term_id, $page_name, $page_location );
	$i++;
    }
//print_r(count($parent_id)."   ");
$name1 = "menu_items_array_".$pos1;
$menu_items_array = json_decode($data[$name1]);
foreach( $menu_items_array as $page_name => $page_location ){
	generate_site_nav_menu_child_item( $menu_primary_obj->term_id, $page_name, $page_location, $parent_id[$pos1]);
}
$name2 = "menu_items_array_".$pos2;
$menu_items_array = json_decode($data[$name2]);
foreach( $menu_items_array as $page_name => $page_location ){
	generate_site_nav_menu_child_item( $menu_primary_obj->term_id, $page_name, $page_location, $parent_id[$pos2]);
}

    $locations_primary_arr = get_theme_mod( 'nav_menu_locations' );
    $locations_primary_arr[$location_target] = $menu_primary_obj->term_id;
    set_theme_mod( 'nav_menu_locations', $locations_primary_arr );
    update_option( 'menu_check', true );
    
global $wpdb;
$results = $wpdb->get_results( "SELECT `option_value` FROM `wp_options` WHERE `option_name` = 'polylang'" );
$ttt = $results[0];
$www = unserialize(get_object_vars($ttt)['option_value']);
$www['nav_menus'][$data['theme']][$data['location_target']][$data['locale']] = $result;
$ppp = serialize($www);
$results2 = $wpdb->query($wpdb->prepare( "UPDATE `wp_options` SET `option_value`= '".$ppp."' WHERE `option_name` = 'polylang'" ));
print_r($results2);
}

//добавление кастомного поля к посту
function acf_posts(WP_REST_Request $request) {  
$data = $request->get_params();
update_field("rating", $data['rating'], $data['id']);
print_r("success ".$data['id']);
}

add_action('rest_api_init', function() {
//Устанавливаем аватарку по урлу
	register_rest_route('set_avatar/v1', '/users/(?P<id>\d+)', [
		'methods' => 'POST',
		'callback' => 'set_avatar_url',
	]);
//создание меню для многоязыкового сайта
register_rest_route('create_menu/v1', '/menus/', [
		'methods' => 'POST',
		'callback' => 'generate_site_nav_menu',
	]);

//получаем все меню используемые на сайте
register_rest_route('get_menu/v1', '/menus/', [
		'methods' => 'GET',
		'callback' => 'get_all_registered_nav_menus',
	]);

//добавление кастомного поля к посту
register_rest_route('add_pros_cons/v1', '/posts/(?P<id>\d+)', [
		'methods' => 'POST',
		'callback' => 'add_pros_cons_to_post',
	]);
});
?>